import {
  InstanceFactory,
} from '@overflow/commons/di/factory';

import { ApplicationContextIDType } from '@overflow/commons/application/type';

import { MessageSource } from './message_source';
import { InstanceDefinitionReader } from './instance_definition_reader';

export class ApplicationContext {
  public static readonly MESSAGE_SOURCE_INSTANCE_NAME: string = 'messageSource';

  private readonly instanceFactoryPostProcessors: InstanceFactoryPostProcessor[] = [];

  private id: ApplicationContextIDType;
  private parent: ApplicationContext;
  private messageSource: MessageSource;
  private instanceFactory: InstanceFactory;
  private instanceDefinitionReader: InstanceDefinitionReader;

  public constructor(parent?: ApplicationContext) {
    this.setParent(parent);
  }

  // Context

  public getID(): ApplicationContextIDType {
    return this.id;
  }
  public setID(id: ApplicationContextIDType): void {
    this.id = id;
  }

  public getApplicationName(): string {
    return undefined;
  }

  public getParent(): ApplicationContext {
    return this.parent;
  }
  public setParent(parent: ApplicationContext): void {
    this.parent = parent;
  }

  public getInstanceFactory(): InstanceFactory {
    return undefined;
  }

  // Configuration

  public addInstanceFactoryPostProcessor(instanceFactoryPostProcessor: InstanceFactoryPostProcessor): void {
    this.instanceFactoryPostProcessors.push(instanceFactoryPostProcessor);
  }
  public getInstanceFactoryPostProcessor(): InstanceFactoryPostProcessor[] {
    return this.instanceFactoryPostProcessors;
  }

  public addApplicationListener(listener: ApplicationListener): void {
    //
  }

  public registerShutdownHook(): void {
    //
  }

  public initMessageSource(): void {
    //
  }

  // MessageSource
  public getMessageSource(): MessageSource {
    return this.messageSource;
  }

  // Lifecycle

  public start(): void {
    //
  }
  public stop(): void {
    //
  }
  public isRunning(): boolean {
    return false;
  }
}
